//========================================================================================
//
//	File:				FWSaveAs.fr
//	Release Version:	$ ODF 2 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================
//
//	ODFRC declaration for a Save As resource which holds binding and user string
//	information. This is used to build a popup menu in the Save As dialog,
//	used to select a kind for exporting data.

#ifndef FWSAVEAS_FR
#define FWSAVEAS_FR

#ifndef FWSTRING_FR
#include "FWString.fr"
#endif

#ifndef FWSAVEAS_K
#include "FWSaveAs.k"
#endif

/*
	FW_SaveAsInfo has several bits of information:
		prompt (usually "Save a copy as:")
		Externalization information (kinds and user names).
	
	Externalization information is available elsewhere: in the nmap resources
	and the kinds registry (FW_CKind). However these are not sufficient for our
	needs, so as much as I'd like to avoid it, we have some duplication of
	information. Problems include: nmaps are MacOS-only; nmaps don't indicate 
	if a type can be exported or only imported; FW_CKind list doesn't include
	"Internet Reference".
*/

type FW_RSaveAsInfo (FW_kSaveAsResourceType) {
	//
	// Prompt (example: "Save a copy as:")
	//
	prompt: FW_RStringData;
#if 0
	integer = $$CountOf (Prompts);
	array Prompts {
		FW_RStringData;
	};
#endif
	
	//
	// Kinds and user names. These aren't quite the same as Binding names
	// so we can't use OpenDoc's namespace utilities to get the user names.
	// Example entry: kODISOPrefix "MIME:image/jpeg", { "as JPEG" };
	//
	integer = $$CountOf (Kinds);
	array Kinds {
		FW_RStringData;
	};
#if 0
	integer = $$CountOf (Kinds);
	array Kinds {
//		MacCreator: longint;	// 'JVWR'
//		MacFileType: longint;	// 'JFIF'
//		WinExtension: wstring;	// ".jpg"
		Kind: wstring;			// kODISOPrefix "MIME:image/jpeg"
		integer = $$CountOf (Names);
		array Names {
			FW_RStringData;
		};
	};
#endif
};

#endif // FWSAVEAS_FR

