//========================================================================================
//
//	File:				SLCyPart.h
//	Release Version:	$ ODF 2 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//	
//	Callback struct for FW_OCyberPartExtension.
//	See FWCyber.doc for theory and operation.
//
//========================================================================================

#ifndef SLCYPART_H
#define SLCYPART_H

#ifndef FWSTRING_H
#include "FWString.h"
#endif

//----------------------------------------------------------------------------------------
// Includes and Class Declarations
//----------------------------------------------------------------------------------------

#ifndef __SOM__
#include <som.xh>
#endif

#ifndef SOM_CyberItem_xh
#include <CyberItem.xh>	// CyberItemList
#endif

struct Environment;
struct FW_SCyberPartExtensionCallbacks;
class ODFrame;
class CyberItem;
class ParameterSet;

//----------------------------------------------------------------------------------------
// UPP Information Enums. Unused; kept only because we might choose to use
// them in the future.
//----------------------------------------------------------------------------------------

#if 0

enum {
	FW_kDoCyberCommandInfo = kCStackBased
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_SCyberPartExtensionCallbacks*))),
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(long))),
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(ODFrame*))),
		| STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(somToken))),
	FW_kOpenCyberItemInfo = kCStackBased
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_SCyberPartExtensionCallbacks*))),
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(CyberItem*))),
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(ODPart*))),
		| STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(ParameterSet*))),
	FW_kSetCyberItemInfo = kCStackBased
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_SCyberPartExtensionCallbacks*))),
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(CyberItem*))),
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(ParameterSet*))),
	FW_kShowCyberItemInfo = kCStackBased
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_SCyberPartExtensionCallbacks*))),
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(CyberItem*))),
	FW_kIsSelectedURLInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(Boolean)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_SCyberPartExtensionCallbacks*))),
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODFrame*))),
	FW_kGetSelectedURLInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(corbastring)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_SCyberPartExtensionCallbacks*))),
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODFrame*))),
	FW_kIsSelectedCyberItemInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(Boolean)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_SCyberPartExtensionCallbacks*))),
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODFrame*))),
	FW_kAcquireSelectedCyberItemsInfo = kCStackBased
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_SCyberPartExtensionCallbacks*))),
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODFrame*))),
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(CyberItemList*))),
	FW_kGetCyberItemWindowInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(ODWindow*)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_SCyberPartExtensionCallbacks*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(CyberItem*)))
};

#endif

//========================================================================================
// Struct FW_SCyberPartExtensionCallbacks
//========================================================================================

/*
	Since this structure is part of the FW_OCyberPartExtension API, and
	may be compiled into a shared library, it needs to have compiler-
	independent alignment.
*/

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif

struct FW_SCyberPartExtensionCallbacks {
	void 			(*openCyberItem) 		(Environment*, FW_SCyberPartExtensionCallbacks*, CyberItem*, ODPart*, ParameterSet*);
	void 			(*setCyberItem) 		(Environment*, FW_SCyberPartExtensionCallbacks*, CyberItem*, ParameterSet*);
	ODBoolean 		(*canShowCyberItem)		(Environment*, FW_SCyberPartExtensionCallbacks*, CyberItem*);
	void 			(*showCyberItem) 		(Environment*, FW_SCyberPartExtensionCallbacks*, CyberItem*);
	ODWindow* 		(*getCyberItemWindow) 	(Environment*, FW_SCyberPartExtensionCallbacks*, CyberItem*);
	ODBoolean 		(*isCyberItemSelected) 	(Environment*, FW_SCyberPartExtensionCallbacks*, ODFrame*);
	void 			(*acquireSelectedCyberItems) (Environment*, FW_SCyberPartExtensionCallbacks*, ODFrame*, CyberItemList*);
	ODBoolean		(*isURLSelected) 		(Environment*, FW_SCyberPartExtensionCallbacks*, ODFrame*);
	void 			(*getSelectedURL) 		(Environment*, FW_SCyberPartExtensionCallbacks*, ODFrame*, FW_CString& url);
	ODBoolean 		(*handleCommand) 		(Environment*, FW_SCyberPartExtensionCallbacks*, long, long, ODFrame*, somToken);
	void 			(*extensionRemoved)		(Environment*, FW_SCyberPartExtensionCallbacks*);
};

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif

#endif // SLCYPART_H

